
with Protected_Machine ;

with Ada.Numerics.Float_Random;

package body Global is

   package Protected_Float_Random is new Protected_Machine
     ( Result			=> Float,
       Internal_State   => Ada.Numerics.Float_Random.Generator,
       Reset            => Ada.Numerics.Float_Random.Reset,
       Next_Value		=> Ada.Numerics.Float_Random.Random);
	   
	   -- the result is a Float value uniformely distributed in the range 0.0..1.0
	   
	function Next_Hazard return Float is
	begin
		return Protected_Float_Random.Next_Protected_Value;
	end Next_Hazard;
	
end Global;
