package Semaphores_O  is
-- ================================================================

-- this package uses a protected object to implement 
-- the type counting Semaphore with primitive operations P, V and Initialize
-- its semantic mimics the initial Dijkstra implementation   type Semaphore is limited private;
-- ================================================================

   type Semaphore is limited private;

   procedure P(S: in out Semaphore);
   -- P for Pass (also "Passeren" in Dutch, "Puis-je" in French)
   procedure V(S: in out Semaphore); 
   -- V for Vote a credit (also "Vrygeven" in Dutch, "Vas-y" in French)

   procedure Initialize(S: in out Semaphore; Val: in Natural);
   -- Initialization of a semaphore count, must be non negative

private
   protected type Sem is
      entry P;
      procedure V;
      procedure E0(Val: Natural);
   private
      Count : Natural := 0; -- controlling value
   end Sem;

   type Semaphore is new Sem;
   
-- ================================================================

end Semaphores_O;
